#include "tcpserver.h"

TcpServer::TcpServer(QObject *parent) :
    QObject(parent)
{
    server = new QTcpServer(this);

    // whenever a user connects, it will emit signal
    connect(server, SIGNAL(newConnection()), this, SLOT(newConnection()));

    if(!server->listen(QHostAddress::Any, 9999))
        {
        qDebug() << "Server could not start";
        exit(1);
        }
    else
        {
        qDebug() << "Server started!";
        }
    
    cmdList.append("G0 X0 Y0 Z0\n");
    cmdList.append("G0 X10 Y10 Z10\n");
    cmdList.append("G0 X20 Y20 Z20\n");
    cmdList.append("G0 X30 Y30 Z30\n");        
    cmdList.append("G0 X0 Y0 Z0\n");  
    cmdIndex = 0;	 	
}

void TcpServer::newConnection()
{
QString str;

    // need to grab the socket
    socket = server->nextPendingConnection();
    connect(socket, SIGNAL(readyRead()), this, SLOT(on_readyRead()));
    str = "ACK\n";
    writeOut(str, socket);

    
}

void TcpServer::on_readyRead()
{
QString str, str1;

    if(socket->bytesAvailable())
        {
        str1 = socket->readLine();
        if(str1.contains("ACK") && (cmdIndex <= 4))
            {
            str = cmdList[cmdIndex++];
	        writeOut(str, socket);
	        }
	    else if(cmdIndex > 4)
	        {
	        str = "NAK\n";
            writeOut(str, socket);
	        }
	    }
}


void TcpServer::writeOut(QString& str, QTcpSocket *sock)
{
    sock->write(str.toLatin1());
    sock->flush();
    sock->waitForBytesWritten(3000);
}
